Index: uspace/lib/posix/test/scanf.c
===================================================================
--- uspace/lib/posix/test/scanf.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/posix/test/scanf.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -27,8 +27,8 @@
  */
 
+#define LIBPOSIX_INTERNAL
+#define __POSIX_DEF__(x) posix_##x
 
-
-#include <errno.h>
-
+#include "posix/errno.h"
 #include "posix/stdio.h"
 
@@ -51,5 +51,5 @@
 PCUT_TEST(int_decimal) {
 	int number;
-	int rc = sscanf("4242", "%d", &number);
+	int rc = posix_sscanf("4242", "%d", &number);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_INT_EQUALS(4242, number);
@@ -58,5 +58,5 @@
 PCUT_TEST(int_negative_decimal) {
 	int number;
-	int rc = sscanf("-53", "%d", &number);
+	int rc = posix_sscanf("-53", "%d", &number);
 	PCUT_ASSERT_INT_EQUALS(1, rc);
 	PCUT_ASSERT_INT_EQUALS(-53, number);
@@ -82,5 +82,5 @@
 	void *p;
 
-	int rc = sscanf(
+	int rc = posix_sscanf(
 		"\n j tt % \t -121314 98765 aqw 0765 0x77 0xABCDEF88 -99 884",
 		" j tt %%%3hhd%1hhu%3hd %3hu%u aqw%n %lo%llx %p %li %lld",
@@ -107,5 +107,5 @@
 	long double ld;
 
-	int rc = sscanf(
+	int rc = posix_sscanf(
 		"\n \t\t1.0 -0x555.AP10 1234.5678e12",
 		"%f %lf %Lf",
@@ -123,5 +123,5 @@
 	char *pstr;
 
-	int rc = sscanf(
+	int rc = posix_sscanf(
 		"\n\n\thello world    \n",
 		"%5s %ms",
@@ -140,5 +140,5 @@
 	char *pscanset;
 
-	int rc = sscanf(
+	int rc = posix_sscanf(
 		"\n\n\th-e-l-l-o world-]    \n",
 		" %9[-eh-o] %m[^]-]",
@@ -157,5 +157,5 @@
 	char *pseq;
 
-	int rc = sscanf(
+	int rc = posix_sscanf(
 		"\n\n\thello world    \n",
 		" %5c %mc",
Index: uspace/lib/trackmod/protracker.c
===================================================================
--- uspace/lib/trackmod/protracker.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/trackmod/protracker.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -79,5 +79,5 @@
  * @return         EOK on success, EINVAL if tag is not recognized.
  */
-static errno_t smp_tag_decode(uint8_t *tag, size_t *channels)
+static int smp_tag_decode(uint8_t *tag, size_t *channels)
 {
 	size_t nentries = sizeof(smp_tags) / sizeof(smptag_desc_t);
@@ -138,9 +138,9 @@
  * @return       EOK on success, ENOMEM if out of memory, EIO on I/O error.
  */
-static errno_t protracker_load_patterns(FILE *f, trackmod_module_t *module)
+static int protracker_load_patterns(FILE *f, trackmod_module_t *module)
 {
 	size_t cells;
 	size_t i, j;
-	errno_t rc;
+	int rc;
 	size_t nread;
 	uint32_t *buf = NULL;
@@ -191,8 +191,8 @@
  * @return       EOk on success, ENOMEM if out of memory, EIO on I/O error.
  */
-static errno_t protracker_load_samples(FILE *f, protracker_smp_t *smp,
+static int protracker_load_samples(FILE *f, protracker_smp_t *smp,
     trackmod_module_t *module)
 {
-	errno_t rc;
+	int rc;
 	size_t i;
 	uint8_t ftval;
@@ -256,5 +256,5 @@
  *                or if any error is found in the format of the file.
  */
-errno_t trackmod_protracker_load(char *fname, trackmod_module_t **rmodule)
+int trackmod_protracker_load(char *fname, trackmod_module_t **rmodule)
 {
 	FILE *f = NULL;
@@ -269,5 +269,5 @@
 	size_t i;
 	size_t nread;
-	errno_t rc;
+	int rc;
 
 	f = fopen(fname, "rb");
@@ -302,5 +302,6 @@
 		memcpy(&mod15, &mod31, sizeof(protracker_15smp_t));
 
-		if (fseek(f, sizeof(protracker_15smp_t), SEEK_SET) < 0) {
+		rc = fseek(f, sizeof(protracker_15smp_t), SEEK_SET);
+		if (rc != 0) {
 			printf("Error seeking.\n");
 			rc = EIO;
Index: uspace/lib/trackmod/protracker.h
===================================================================
--- uspace/lib/trackmod/protracker.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/trackmod/protracker.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include "types/trackmod.h"
 
-extern errno_t trackmod_protracker_load(char *, trackmod_module_t **);
+extern int trackmod_protracker_load(char *, trackmod_module_t **);
 
 #endif
Index: uspace/lib/trackmod/trackmod.c
===================================================================
--- uspace/lib/trackmod/trackmod.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/trackmod/trackmod.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -152,7 +152,7 @@
 }
 
-errno_t trackmod_module_load(char *fname, trackmod_module_t **rmodule)
-{
-	errno_t rc;
+int trackmod_module_load(char *fname, trackmod_module_t **rmodule)
+{
+	int rc;
 
 	rc = trackmod_xm_load(fname, rmodule);
@@ -780,5 +780,5 @@
  * @param rmodplay Place to store pointer to module playback object
  */
-errno_t trackmod_modplay_create(trackmod_module_t *module,
+int trackmod_modplay_create(trackmod_module_t *module,
     unsigned smp_freq, trackmod_modplay_t **rmodplay)
 {
Index: uspace/lib/trackmod/trackmod.h
===================================================================
--- uspace/lib/trackmod/trackmod.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/trackmod/trackmod.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,7 +40,7 @@
 
 extern trackmod_module_t *trackmod_module_new(void);
-extern errno_t trackmod_module_load(char *, trackmod_module_t **);
+extern int trackmod_module_load(char *, trackmod_module_t **);
 extern void trackmod_module_destroy(trackmod_module_t *);
-extern errno_t trackmod_modplay_create(trackmod_module_t *, unsigned,
+extern int trackmod_modplay_create(trackmod_module_t *, unsigned,
     trackmod_modplay_t **);
 extern void trackmod_modplay_destroy(trackmod_modplay_t *);
Index: uspace/lib/trackmod/xm.c
===================================================================
--- uspace/lib/trackmod/xm.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/trackmod/xm.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,7 +53,7 @@
  * @return EOK on success, EIO on format error, ENOMEM if out of memory.
  */
-static errno_t trackmod_xm_load_order_list(xm_hdr_t *xm_hdr, trackmod_module_t *module)
-{
-	errno_t rc;
+static int trackmod_xm_load_order_list(xm_hdr_t *xm_hdr, trackmod_module_t *module)
+{
+	int rc;
 	size_t i;
 
@@ -94,5 +94,5 @@
  * @return	  EOK on success, EINVAL if there is error in the coded data.
  */
-static errno_t trackmod_xm_decode_pattern(uint8_t *data, size_t dsize,
+static int trackmod_xm_decode_pattern(uint8_t *data, size_t dsize,
     trackmod_pattern_t *pattern)
 {
@@ -162,5 +162,5 @@
  * @return EOK on success, EIO on format error, ENOMEM if out of memory.
  */
-static errno_t trackmod_xm_load_patterns(FILE *f, trackmod_module_t *module)
+static int trackmod_xm_load_patterns(FILE *f, trackmod_module_t *module)
 {
 	size_t i;
@@ -173,6 +173,5 @@
 	uint8_t *buf = NULL;
 	long seek_amount;
-	errno_t rc;
-	int ret;
+	int rc;
 
 	module->pattern = calloc(sizeof(trackmod_pattern_t), module->patterns);
@@ -183,6 +182,6 @@
 
 	for (i = 0; i < module->patterns; i++) {
-		ret = fread(&pattern, 1, sizeof(xm_pattern_t), f);
-		if (ret != sizeof(xm_pattern_t)) {
+		rc = fread(&pattern, 1, sizeof(xm_pattern_t), f);
+		if (rc != sizeof(xm_pattern_t)) {
 			rc = EIO;
 			goto error;
@@ -281,5 +280,5 @@
  * @return EOK on success, EIO on format error, ENOMEM if out of memory.
  */
-static errno_t trackmod_xm_load_instruments(xm_hdr_t *xm_hdr, FILE *f,
+static int trackmod_xm_load_instruments(xm_hdr_t *xm_hdr, FILE *f,
     trackmod_module_t *module)
 {
@@ -297,6 +296,5 @@
 	void *smp_data;
 	long pos;
-	errno_t rc;
-	int ret;
+	int rc;
 
 	module->instrs = uint16_t_le2host(xm_hdr->instruments);
@@ -307,6 +305,6 @@
 	for (i = 0; i < module->instrs; i++) {
 		pos = ftell(f);
-		ret = fread(&instr, 1, sizeof(xm_instr_t), f);
-		if (ret != sizeof(xm_instr_t)) {
+		rc = fread(&instr, 1, sizeof(xm_instr_t), f);
+		if (rc != sizeof(xm_instr_t)) {
 			rc = EIO;
 			goto error;
@@ -317,6 +315,6 @@
 
 		if (samples > 0) {
-			ret = fread(&instrx, 1, sizeof(xm_instr_ext_t), f);
-			if (ret != sizeof(xm_instr_ext_t)) {
+			rc = fread(&instrx, 1, sizeof(xm_instr_ext_t), f);
+			if (rc != sizeof(xm_instr_ext_t)) {
 				rc = EIO;
 				goto error;
@@ -348,6 +346,6 @@
 			pos = ftell(f);
 
-			ret = fread(&smp, 1, sizeof(xm_smp_t), f);
-			if (ret != sizeof(xm_smp_t)) {
+			rc = fread(&smp, 1, sizeof(xm_smp_t), f);
+			if (rc != sizeof(xm_smp_t)) {
 				rc = EIO;
 				goto error;
@@ -422,5 +420,5 @@
  *                or if any error is found in the format of the file.
  */
-errno_t trackmod_xm_load(char *fname, trackmod_module_t **rmodule)
+int trackmod_xm_load(char *fname, trackmod_module_t **rmodule)
 {
 	FILE *f = NULL;
@@ -429,5 +427,5 @@
 	size_t nread;
 	size_t hdr_size;
-	errno_t rc;
+	int rc;
 
 	f = fopen(fname, "rb");
Index: uspace/lib/trackmod/xm.h
===================================================================
--- uspace/lib/trackmod/xm.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/trackmod/xm.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -39,5 +39,5 @@
 #include "types/trackmod.h"
 
-extern errno_t trackmod_xm_load(char *, trackmod_module_t **);
+extern int trackmod_xm_load(char *, trackmod_module_t **);
 
 #endif
Index: uspace/lib/uri/ctype.h
===================================================================
--- uspace/lib/uri/ctype.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
+++ uspace/lib/uri/ctype.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -0,0 +1,95 @@
+/*
+ * Copyright (c) 2013 Martin Sucha
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup uri
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef URI_CTYPE_H_
+#define URI_CTYPE_H_
+
+static inline bool is_unreserved(char c)
+{
+	return isalpha(c) || isdigit(c) ||
+	    c == '-' || c == '.' || c == '_' || c == '~';
+}
+
+static inline bool is_hexdig(char c)
+{
+	return (c >= '0' && c <= '9') || (c >= 'a' && c <= 'f') ||
+	    (c >= 'A' && c <= 'F');
+}
+
+static inline bool is_subdelim(char c)
+{
+	switch (c) {
+	case '!':
+	case '$':
+	case '&':
+	case '\'':
+	case '(':
+	case ')':
+	case '*':
+	case '+':
+	case ',':
+	case ';':
+	case '=':
+		return true;
+	default:
+		return false;
+	}
+}
+
+static inline bool is_gendelim(char c)
+{
+	switch (c) {
+	case ':':
+	case '/':
+	case '?':
+	case '#':
+	case '[':
+	case ']':
+	case '@':
+		return true;
+	default:
+		return false;
+	}
+}
+
+static inline bool is_reserved(char c)
+{
+	return is_gendelim(c) || is_subdelim(c);
+}
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/uri/uri.c
===================================================================
--- uspace/lib/uri/uri.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/uri/uri.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 
 #include "uri.h"
-#include "internal/ctype.h"
+#include "ctype.h"
 
 static char *cut_str(const char *start, const char *end)
@@ -143,5 +143,5 @@
  * @return EOK on success
  */
-errno_t uri_scheme_parse(const char *str, const char **endptr)
+int uri_scheme_parse(const char *str, const char **endptr)
 {
 	if (*str == 0) {
@@ -175,5 +175,5 @@
 }
 
-errno_t uri_percent_parse(const char *str, const char **endptr,
+int uri_percent_parse(const char *str, const char **endptr,
     uint8_t *decoded)
 {
@@ -186,5 +186,5 @@
 	
 	if (decoded != NULL) {
-		errno_t rc = str_uint8_t(str + 1, NULL, 16, true, decoded);
+		int rc = str_uint8_t(str + 1, NULL, 16, true, decoded);
 		if (rc != EOK)
 			return rc;
@@ -195,5 +195,5 @@
 }
 
-errno_t uri_user_info_parse(const char *str, const char **endptr)
+int uri_user_info_parse(const char *str, const char **endptr)
 {
 	while (*str != 0) {
@@ -201,5 +201,5 @@
 		if (*str == 0)
 			break;
-		errno_t rc = uri_percent_parse(str, &str, NULL);
+		int rc = uri_percent_parse(str, &str, NULL);
 		if (rc != EOK) {
 			*endptr = str;
@@ -220,5 +220,5 @@
 }
 
-errno_t uri_port_parse(const char *str, const char **endptr)
+int uri_port_parse(const char *str, const char **endptr)
 {
 	if (*str == 0)
Index: uspace/lib/uri/uri.h
===================================================================
--- uspace/lib/uri/uri.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/uri/uri.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -49,10 +49,10 @@
 
 extern uri_t *uri_parse(const char *);
-extern errno_t uri_scheme_parse(const char *, const char **);
+extern int uri_scheme_parse(const char *, const char **);
 extern bool uri_scheme_validate(const char *);
-extern errno_t uri_percent_parse(const char *, const char **, uint8_t *);
-extern errno_t uri_user_info_parse(const char *, const char **);
+extern int uri_percent_parse(const char *, const char **, uint8_t *);
+extern int uri_user_info_parse(const char *, const char **);
 extern bool uri_user_info_validate(const char *);
-extern errno_t uri_port_parse(const char *, const char **);
+extern int uri_port_parse(const char *, const char **);
 extern bool uri_port_validate(const char *);
 extern bool uri_validate(uri_t *);
Index: uspace/lib/usb/include/usb/dev.h
===================================================================
--- uspace/lib/usb/include/usb/dev.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usb/include/usb/dev.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,5 +40,5 @@
 #include <devman.h>
 
-extern errno_t usb_resolve_device_handle(const char *, devman_handle_t *);
+extern int usb_resolve_device_handle(const char *, devman_handle_t *);
 
 #endif
Index: uspace/lib/usb/src/debug.c
===================================================================
--- uspace/lib/usb/src/debug.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usb/src/debug.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -36,5 +36,4 @@
 #include <ddf/log.h>
 #include <usb/debug.h>
-#include <str.h>
 
 #define REMAINDER_STR_FMT " (%zu)..."
Index: uspace/lib/usb/src/dev.c
===================================================================
--- uspace/lib/usb/src/dev.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usb/src/dev.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -53,5 +53,5 @@
  * @return Error code.
  */
-errno_t usb_resolve_device_handle(const char *dev_path, devman_handle_t *dev_handle)
+int usb_resolve_device_handle(const char *dev_path, devman_handle_t *dev_handle)
 {
 	if (dev_path == NULL || dev_handle == NULL) {
@@ -60,5 +60,5 @@
 
 	/* First, try to get the device handle. */
-	errno_t rc = devman_fun_get_handle(dev_path, dev_handle, 0);
+	int rc = devman_fun_get_handle(dev_path, dev_handle, 0);
 
 	/* Next, try parsing dev_handle from the provided string */
Index: uspace/lib/usbdev/include/usb/dev/alternate_ifaces.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/alternate_ifaces.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/include/usb/dev/alternate_ifaces.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -38,5 +38,4 @@
 #define LIBUSBDEV_ALTERNATE_IFACES_H_
 
-#include <errno.h>
 #include <usb/descriptor.h>
 #include <stddef.h>
@@ -59,5 +58,5 @@
 typedef struct {
 	/** Array of alternate interfaces descriptions. */
-	usb_alternate_interface_descriptors_t *alternatives;
+	const usb_alternate_interface_descriptors_t *alternatives;
 	/** Size of @c alternatives array. */
 	size_t alternative_count;
@@ -67,5 +66,5 @@
 
 size_t usb_interface_count_alternates(const uint8_t *, size_t, uint8_t);
-errno_t usb_alternate_interfaces_init(usb_alternate_interfaces_t *,
+int usb_alternate_interfaces_init(usb_alternate_interfaces_t *,
     const uint8_t *, size_t, int);
 void usb_alternate_interfaces_deinit(usb_alternate_interfaces_t *);
Index: uspace/lib/usbdev/include/usb/dev/device.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/device.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/include/usb/dev/device.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -51,5 +51,5 @@
 	usb_standard_device_descriptor_t device;
 	/** Full configuration descriptor of current configuration. */
-	void *full_config;
+	const void *full_config;
 	size_t full_config_size;
 } usb_device_descriptors_t;
@@ -58,5 +58,5 @@
 
 /* DDF parts */
-errno_t usb_device_create_ddf(ddf_dev_t *, const usb_endpoint_description_t **, const char **);
+int usb_device_create_ddf(ddf_dev_t *, const usb_endpoint_description_t **, const char **);
 void usb_device_destroy_ddf(ddf_dev_t *);
 
@@ -76,8 +76,8 @@
 void usb_device_bus_exchange_end(async_exch_t *);
 
-errno_t usb_device_select_interface(usb_device_t *, uint8_t,
+int usb_device_select_interface(usb_device_t *, uint8_t,
     const usb_endpoint_description_t **);
 
-errno_t usb_device_create_pipes(usb_device_t *usb_dev,
+int usb_device_create_pipes(usb_device_t *usb_dev,
     const usb_endpoint_description_t **endpoints);
 void usb_device_destroy_pipes(usb_device_t *);
Index: uspace/lib/usbdev/include/usb/dev/driver.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/driver.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/include/usb/dev/driver.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,9 @@
 typedef struct {
 	/** Callback when a new device was added to the system. */
-	errno_t (*device_add)(usb_device_t *);
+	int (*device_add)(usb_device_t *);
 	/** Callback when a device is about to be removed from the system. */
-	errno_t (*device_rem)(usb_device_t *);
+	int (*device_rem)(usb_device_t *);
 	/** Callback when a device was removed from the system. */
-	errno_t (*device_gone)(usb_device_t *);
+	int (*device_gone)(usb_device_t *);
 } usb_driver_ops_t;
 
Index: uspace/lib/usbdev/include/usb/dev/pipes.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/pipes.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/include/usb/dev/pipes.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -109,21 +109,21 @@
 } usb_endpoint_mapping_t;
 
-errno_t usb_pipe_initialize(usb_pipe_t *, usb_endpoint_t, usb_transfer_type_t,
+int usb_pipe_initialize(usb_pipe_t *, usb_endpoint_t, usb_transfer_type_t,
     size_t, usb_direction_t, unsigned, usb_dev_session_t *);
-errno_t usb_pipe_initialize_default_control(usb_pipe_t *, usb_dev_session_t *);
+int usb_pipe_initialize_default_control(usb_pipe_t *, usb_dev_session_t *);
 
-errno_t usb_pipe_probe_default_control(usb_pipe_t *);
-errno_t usb_pipe_initialize_from_configuration(usb_endpoint_mapping_t *,
+int usb_pipe_probe_default_control(usb_pipe_t *);
+int usb_pipe_initialize_from_configuration(usb_endpoint_mapping_t *,
     size_t, const uint8_t *, size_t, usb_dev_session_t *);
 
-errno_t usb_pipe_register(usb_pipe_t *, unsigned);
-errno_t usb_pipe_unregister(usb_pipe_t *);
+int usb_pipe_register(usb_pipe_t *, unsigned);
+int usb_pipe_unregister(usb_pipe_t *);
 
-errno_t usb_pipe_read(usb_pipe_t *, void *, size_t, size_t *);
-errno_t usb_pipe_write(usb_pipe_t *, const void *, size_t);
+int usb_pipe_read(usb_pipe_t *, void *, size_t, size_t *);
+int usb_pipe_write(usb_pipe_t *, const void *, size_t);
 
-errno_t usb_pipe_control_read(usb_pipe_t *, const void *, size_t,
+int usb_pipe_control_read(usb_pipe_t *, const void *, size_t,
     void *, size_t, size_t *);
-errno_t usb_pipe_control_write(usb_pipe_t *, const void *, size_t,
+int usb_pipe_control_write(usb_pipe_t *, const void *, size_t,
     const void *, size_t);
 
Index: uspace/lib/usbdev/include/usb/dev/poll.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/poll.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/include/usb/dev/poll.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -87,5 +87,5 @@
 	 * @return Whether to continue in polling.
 	 */
-	bool (*on_error)(usb_device_t *dev, errno_t err_code, void *arg);
+	bool (*on_error)(usb_device_t *dev, int err_code, void *arg);
 	/** Argument to pass to callbacks. */
 	void *arg;
@@ -95,15 +95,15 @@
 typedef void (*usb_polling_terminted_callback_t)(usb_device_t *, bool, void *);
 
-extern errno_t usb_device_auto_polling(usb_device_t *, usb_endpoint_t,
+extern int usb_device_auto_polling(usb_device_t *, usb_endpoint_t,
     const usb_device_auto_polling_t *, size_t);
 
-extern errno_t usb_device_auto_poll(usb_device_t *, usb_endpoint_t,
+extern int usb_device_auto_poll(usb_device_t *, usb_endpoint_t,
     usb_polling_callback_t, size_t, int, usb_polling_terminted_callback_t, void *);
 
-extern errno_t usb_device_auto_polling_desc(usb_device_t *,
+extern int usb_device_auto_polling_desc(usb_device_t *,
     const usb_endpoint_description_t *, const usb_device_auto_polling_t *,
     size_t);
 
-extern errno_t usb_device_auto_poll_desc(usb_device_t *,
+extern int usb_device_auto_poll_desc(usb_device_t *,
     const usb_endpoint_description_t *, usb_polling_callback_t, size_t, int,
     usb_polling_terminted_callback_t, void *);
Index: uspace/lib/usbdev/include/usb/dev/recognise.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/recognise.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/include/usb/dev/recognise.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,12 +42,12 @@
 #include <devman.h>
 
-extern errno_t usb_device_create_match_ids_from_device_descriptor(
+extern int usb_device_create_match_ids_from_device_descriptor(
     const usb_standard_device_descriptor_t *, match_id_list_t *);
 
-extern errno_t usb_device_create_match_ids_from_interface(
+extern int usb_device_create_match_ids_from_interface(
     const usb_standard_device_descriptor_t *,
     const usb_standard_interface_descriptor_t *, match_id_list_t *);
 
-extern errno_t usb_device_create_match_ids(usb_pipe_t *, match_id_list_t *);
+extern int usb_device_create_match_ids(usb_pipe_t *, match_id_list_t *);
 
 #endif
Index: uspace/lib/usbdev/include/usb/dev/request.h
===================================================================
--- uspace/lib/usbdev/include/usb/dev/request.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/include/usb/dev/request.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,48 +44,48 @@
 #include <usb/request.h>
 
-errno_t usb_control_request_set(usb_pipe_t *,
+int usb_control_request_set(usb_pipe_t *,
     usb_request_type_t, usb_request_recipient_t, uint8_t,
     uint16_t, uint16_t, const void *, size_t);
 
-errno_t usb_control_request_get(usb_pipe_t *,
+int usb_control_request_get(usb_pipe_t *,
     usb_request_type_t, usb_request_recipient_t, uint8_t,
     uint16_t, uint16_t, void *, size_t, size_t *);
 
-errno_t usb_request_get_status(usb_pipe_t *, usb_request_recipient_t,
+int usb_request_get_status(usb_pipe_t *, usb_request_recipient_t,
     uint16_t, uint16_t *);
-errno_t usb_request_clear_feature(usb_pipe_t *, usb_request_type_t,
+int usb_request_clear_feature(usb_pipe_t *, usb_request_type_t,
     usb_request_recipient_t, uint16_t, uint16_t);
-errno_t usb_request_set_feature(usb_pipe_t *, usb_request_type_t,
+int usb_request_set_feature(usb_pipe_t *, usb_request_type_t,
     usb_request_recipient_t, uint16_t, uint16_t);
-errno_t usb_request_get_descriptor(usb_pipe_t *, usb_request_type_t,
+int usb_request_get_descriptor(usb_pipe_t *, usb_request_type_t,
     usb_request_recipient_t, uint8_t, uint8_t, uint16_t, void *, size_t,
     size_t *);
-errno_t usb_request_get_descriptor_alloc(usb_pipe_t *, usb_request_type_t,
+int usb_request_get_descriptor_alloc(usb_pipe_t *, usb_request_type_t,
     usb_request_recipient_t, uint8_t, uint8_t, uint16_t, void **, size_t *);
-errno_t usb_request_get_device_descriptor(usb_pipe_t *,
+int usb_request_get_device_descriptor(usb_pipe_t *,
     usb_standard_device_descriptor_t *);
-errno_t usb_request_get_bare_configuration_descriptor(usb_pipe_t *, int,
+int usb_request_get_bare_configuration_descriptor(usb_pipe_t *, int,
     usb_standard_configuration_descriptor_t *);
-errno_t usb_request_get_full_configuration_descriptor(usb_pipe_t *, int,
+int usb_request_get_full_configuration_descriptor(usb_pipe_t *, int,
     void *, size_t, size_t *);
-errno_t usb_request_get_full_configuration_descriptor_alloc(usb_pipe_t *,
-    int, void **, size_t *);
-errno_t usb_request_set_descriptor(usb_pipe_t *, usb_request_type_t,
+int usb_request_get_full_configuration_descriptor_alloc(usb_pipe_t *,
+    int, const void **, size_t *);
+int usb_request_set_descriptor(usb_pipe_t *, usb_request_type_t,
     usb_request_recipient_t, uint8_t, uint8_t, uint16_t, const void *, size_t);
 
-errno_t usb_request_get_configuration(usb_pipe_t *, uint8_t *);
-errno_t usb_request_set_configuration(usb_pipe_t *, uint8_t);
+int usb_request_get_configuration(usb_pipe_t *, uint8_t *);
+int usb_request_set_configuration(usb_pipe_t *, uint8_t);
 
-errno_t usb_request_get_interface(usb_pipe_t *, uint8_t, uint8_t *);
-errno_t usb_request_set_interface(usb_pipe_t *, uint8_t, uint8_t);
+int usb_request_get_interface(usb_pipe_t *, uint8_t, uint8_t *);
+int usb_request_set_interface(usb_pipe_t *, uint8_t, uint8_t);
 
-errno_t usb_request_get_supported_languages(usb_pipe_t *,
+int usb_request_get_supported_languages(usb_pipe_t *,
     l18_win_locales_t **, size_t *);
-errno_t usb_request_get_string(usb_pipe_t *, size_t, l18_win_locales_t,
+int usb_request_get_string(usb_pipe_t *, size_t, l18_win_locales_t,
     char **);
 
-errno_t usb_request_clear_endpoint_halt(usb_pipe_t *, uint16_t);
-errno_t usb_pipe_clear_halt(usb_pipe_t *, usb_pipe_t *);
-errno_t usb_request_get_endpoint_status(usb_pipe_t *, usb_pipe_t *, uint16_t *);
+int usb_request_clear_endpoint_halt(usb_pipe_t *, uint16_t);
+int usb_pipe_clear_halt(usb_pipe_t *, usb_pipe_t *);
+int usb_request_get_endpoint_status(usb_pipe_t *, usb_pipe_t *, uint16_t *);
 
 #endif
Index: uspace/lib/usbdev/src/altiface.c
===================================================================
--- uspace/lib/usbdev/src/altiface.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/src/altiface.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -88,5 +88,5 @@
  * @return Error code.
  */
-errno_t usb_alternate_interfaces_init(usb_alternate_interfaces_t *alternates,
+int usb_alternate_interfaces_init(usb_alternate_interfaces_t *alternates,
     const uint8_t *config_descr, size_t config_descr_size, int interface_number)
 {
Index: uspace/lib/usbdev/src/devdrv.c
===================================================================
--- uspace/lib/usbdev/src/devdrv.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/lib/usbdev/src/devdrv.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -131,5 +131,5 @@
  * @return Error code.
  */
-errno_t usb_device_select_interface(usb_device_t *usb_dev,
+int usb_device_select_interface(usb_device_t *usb_dev,
     uint8_t alternate_setting, const usb_endpoint_description_t **endpoints)
 {
@@ -141,5 +141,5 @@
 
 	/* Change the interface itself. */
-	errno_t rc = usb_request_set_interface(&usb_dev->ctrl_pipe,
+	int rc = usb_request_set_interface(&usb_dev->ctrl_pipe,
 	    usb_dev->interface_no, alternate_setting);
 	if (rc != EOK) {
@@ -165,5 +165,5 @@
  * @return Error code.
  */
-static errno_t usb_device_retrieve_descriptors(usb_device_t *usb_dev)
+static int usb_device_retrieve_descriptors(usb_device_t *usb_dev)
 {
 	assert(usb_dev);
@@ -171,5 +171,5 @@
 
 	/* Get the device descriptor. */
-	errno_t rc = usb_request_get_device_descriptor(&usb_dev->ctrl_pipe,
+	int rc = usb_request_get_device_descriptor(&usb_dev->ctrl_pipe,
 	    &usb_dev->descriptors.device);
 	if (rc != EOK) {
@@ -217,5 +217,5 @@
  * @return Error code.
  */
-errno_t usb_device_create_pipes(usb_device_t *usb_dev,
+int usb_device_create_pipes(usb_device_t *usb_dev,
     const usb_endpoint_description_t **endpoints)
 {
@@ -245,5 +245,5 @@
 
 	/* Find the mapping from configuration descriptor. */
-	errno_t rc = usb_pipe_initialize_from_configuration(pipes, pipe_count,
+	int rc = usb_pipe_initialize_from_configuration(pipes, pipe_count,
 	    usb_dev->descriptors.full_config,
 	    usb_dev->descriptors.full_config_size,
@@ -393,5 +393,5 @@
  * @return Error code.
  */
-static errno_t usb_device_init(usb_device_t *usb_dev, ddf_dev_t *ddf_dev,
+static int usb_device_init(usb_device_t *usb_dev, ddf_dev_t *ddf_dev,
     const usb_endpoint_description_t **endpoints, const char **errstr_ptr,
     devman_handle_t handle, int interface_no)
@@ -420,5 +420,5 @@
 	/* This pipe was registered by the hub driver,
 	 * during device initialization. */
-	errno_t rc = usb_pipe_initialize_default_control(
+	int rc = usb_pipe_initialize_default_control(
 	    &usb_dev->ctrl_pipe, usb_dev->bus_session);
 	if (rc != EOK) {
@@ -457,5 +457,5 @@
 }
 
-static errno_t usb_device_get_info(async_sess_t *sess, devman_handle_t *handle,
+static int usb_device_get_info(async_sess_t *sess, devman_handle_t *handle,
 	int *iface_no)
 {
@@ -467,5 +467,5 @@
 		return EPARTY;
 	
-	errno_t ret = usb_get_my_device_handle(exch, handle);
+	int ret = usb_get_my_device_handle(exch, handle);
 	if (ret == EOK) {
 		ret = usb_get_my_interface(exch, iface_no);
@@ -480,5 +480,5 @@
 }
 
-errno_t usb_device_create_ddf(ddf_dev_t *ddf_dev,
+int usb_device_create_ddf(ddf_dev_t *ddf_dev,
     const usb_endpoint_description_t **desc, const char **err)
 {
@@ -492,5 +492,5 @@
 	if (sess == NULL)
 		return ENOMEM;
-	const errno_t ret = usb_device_get_info(sess, &h, &iface_no);
+	const int ret = usb_device_get_info(sess, &h, &iface_no);
 	if (ret != EOK)
 		return ret;
@@ -521,5 +521,5 @@
 
 	async_sess_t *sess = devman_device_connect(handle, IPC_FLAG_BLOCKING);
-	errno_t ret = usb_device_get_info(sess, &h, &iface_no);
+	int ret = usb_device_get_info(sess, &h, &iface_no);
 	if (sess)
 		async_hangup(sess);
